from flask import Flask, render_template, request, redirect, url_for
from wtforms import Form, StringField, PasswordField, validators, TextAreaField
from os import path, walk
import os
import uuid

codes_db = os.path.dirname(os.path.realpath(__file__)) + '/challenge/codes.db'
chpin_db = os.path.dirname(os.path.realpath(__file__)) + '/../chpin.db'
chxfer_db = os.path.dirname(os.path.realpath(__file__)) + '/../chxfer.db'
erlog_db = os.path.dirname(os.path.realpath(__file__)) + '/../erlog.log'
challenge_count = 0
challenges = {}

#extra_dirs = ['/home/dr1p/g1mp/flask/challenge',]
#extra_files = extra_dirs[:]
#for extra_dir in extra_dirs:
#    for dirname, dirs, files in walk(extra_dir):
#        for filename in files:
#            filename = path.join(dirname, filename)
#            if path.isfile(filename):
#                extra_files.append(filename)

app = Flask(__name__)

class UserChallengeForm(Form):
    challenge = StringField('challenge',[validators.Length(min=32, max=32)])
class UserPinForm(Form):
    pin = StringField('pin',[validators.Length(min=8, max=16)])
class UserXferForm(Form):
    xfer = StringField('xfer',[validators.Length(min=8, max=16)])
class UserValidateForm(Form):
    passphrase = StringField('passphrase',[validators.DataRequired()])
    text = TextAreaField('Text', [validators.DataRequired()])

@app.route('/xfer/<id>', methods=["GET", "POST"])
def user_xfer(id):
    global challenges
    try:
        challenges.update({ id: challenges[id]+1})
    except:
        return render_template("null.html")
    f = open(codes_db,'r')
    l = f.read().splitlines()
    f.close()
    if challenges[id] > 2:
        for _ in l:
            if _.split()[0] == id:
                fff = open(erlog_db,'a')
                fff.write('{} {} {} {}\n'.format(id,challenges[id],_.split()[1],_.split()[2]))
                fff.close()
        challenges.pop(id)
        ff = open(codes_db,'w')
        for _ in l:
            try:
                if not _.split()[0] == challenge_input:
                    ff.write(f'{_}\n')
            except:
                pass
        ff.close()
    challenge_input = id
    FLAG=0
    for _ in l:
        if _.split()[0] == challenge_input:
            FLAG=1
    if FLAG == 0:
        return render_template("null.html")

    form = UserXferForm(request.form)
    if request.method == "POST" and form.validate():
        f = open(codes_db,'w')
        ff = open(chxfer_db,'a')
        challenge=uuid.uuid4().hex[:8]
        for _ in l:
            try:
                if not _.split()[0] == challenge_input:
                    f.write(f'{_}\n')
                else:
                    ff.write(f'{_.split()[2]} {form.xfer.data} {challenge}\n')
            except:
                pass
        f.close()
        ff.close()
        print(f'id: {challenges[id]}')
        msg = '<html><body text="cyan" bgcolor="black">xfer: pending<br><br>'
        msg = msg + 'in a few moments g1mp will confirm or deny your transfer</body></html>'.format(challenge)
        return msg
    return render_template("xfer.html")

@app.route('/pin/<id>', methods=["GET", "POST"])
def user_pin(id):
    global challenges
    try:
        challenges.update({ id: challenges[id]+1})
    except:
        return render_template("null.html")
    f = open(codes_db,'r')
    l = f.read().splitlines()
    f.close()
    if challenges[id] > 2:
        for _ in l:
            if _.split()[0] == id:
                fff = open(erlog_db,'a')
                fff.write('{} {} {} {}\n'.format(id,challenges[id],_.split()[1],_.split()[2]))
                fff.close()
        challenges.pop(id)
        ff = open(codes_db,'w')
        for _ in l:
            try:
                if not _.split()[0] == challenge_input:
                    ff.write(f'{_}\n')
            except:
                pass
        ff.close()
    challenge_input = id
    FLAG=0
    for _ in l:
        if _.split()[0] == challenge_input:
            FLAG=1
    if FLAG == 0:
        return render_template("null.html")

    form = UserPinForm(request.form)
    if request.method == "POST" and form.validate():
        f = open(codes_db,'w')
        ff = open(chpin_db,'a')
        challenge=uuid.uuid4().hex[:8]
        for _ in l:
            try:
                if not _.split()[0] == challenge_input:
                    f.write(f'{_}\n')
                else:
                    ff.write(f'{_.split()[2]} {form.pin.data} {challenge}\n')
            except:
                pass
        f.close()
        ff.close()
        print(f'id: {challenges[id]}')
        msg = '<html><body text="cyan" bgcolor="black">important: store both the pin and challenge<br><br>'
        msg = msg + 'pin: {}<br>'.format(form.pin.data)
        msg = msg + 'challenge: {}<br><br>in a few moments g1mp will contact you confirming completion</body></html>'.format(challenge)
        return msg
    return render_template("pin.html")

@app.route('/', methods=["GET", "POST"])
def user_null():
    return render_template("null.html")

@app.route('/<id>', methods=["GET", "POST"])
def user_challenge(id):
    f = open(codes_db,'r')
    l = f.read().splitlines()
    f.close()
    challenge_input = id
    global challenges
    try:
        test = challenges[id]
        challenges.update({ id: challenges[id]+1 })
    except:
        challenges.update({ id: 0 })
    for _ in l:
        if _.split()[0] == challenge_input:
            challenge_form = _.split()[1]
            print('user_{}'.format(challenge_form))
            return redirect(url_for('user_{}'.format(challenge_form),id="{}".format(challenge_input)))
        return render_template("null.html")
    return render_template("null.html")

if __name__ == "__main__":
    serve(app) #app.run(host='0.0.0.0',port='54321',extra_files=extra_files)


